property range_list : {"","","T",""}

try
	tell application "iCal"
		activate
		set the calendar_list to the title of every calendar
		set the beginning of the calendar_list to "*ׂẴJ_[*"
		set the source_calendar to (choose from list calendar_list with prompt "J_[IĂ")
		if the source_calendar is false then error number -128
		if the source_calendar is {"*ׂẴJ_[*"} then
			set the calendar_list to the title of every calendar
		else
			set the the calendar_list to the source_calendar
		end if
		
		set the summary_range to (choose from list range_list with prompt "͈͂w肵Ă") as string
		if the summary_range is "false" then
			error number -128
		else
			repeat with i from 1 to the count of the range_list
				if item i of the range_list is the summary_range then
					set the range_indicator to i
					exit repeat
				end if
			end repeat
		end if
		
		if the range_indicator is 1 then -- today
			set current_date to the current date
			set start_day to (current_date - (time of current_date))
			set end_day to (start_day + (1 * days)) - 1
			set the range_text to ""
		else if the range_indicator is 2 then -- tomorrow
			set current_date to the current date
			set start_day to (current_date - (time of current_date)) + (1 * days)
			set end_day to (start_day + (1 * days)) - 1
			set the range_text to ""
		else if the range_indicator is 3 then -- week
			copy my week_of((current date)) to {start_day, end_day}
			set the range_text to "T"
		else if the range_indicator is 4 then -- month
			copy my month_of((current date)) to {start_day, end_day}
			set the range_text to ""
		end if
		
		display dialog "^[Qbgw肵Ă" buttons {"Nbv{[h","eLXgGfBbg","4D"}
		set the summary_destination to the button returned of the result
	end tell
	
	set the master_data to ""
	repeat with i from 1 to the count of the calendar_list
		set the calendar_title to item i of the calendar_list
		if the master_data is "" then
			set the master_data to my calendar_events(calendar_title, start_day, end_day, range_text)
		else
			set the master_data to the master_data & return & return & my calendar_events(calendar_title, start_day, end_day, range_text)
		end if
	end repeat
	
	if the summary_destination is "Nbv{[h" then
		set the clipboard to the master_data
	else if the summary_destination is "eLXgGfBbg" then
		tell application "TextEdit"
			activate
			make new document at the beginning of documents
			set the text of document 1 to the master_data
		end tell
	else
		do shell script "echo " & quoted form of master_data & " > $PATH"
	end if
	beep 2
on error error_message number error_number
	if the error_number is not -128 then
		display dialog error_message buttons {"OK"} default button 1
	end if
end try

on calendar_events(source_calendar, start_day, end_day, range_text)
	tell application "iCal"
		set this_calendar to the first calendar whose title is the source_calendar
		set the returned_events to every event of this_calendar whose start date is greater than or equal to start_day and start date is less than or equal to the end_day
		set these_events to {}
		repeat with i from 1 to the count of the returned_events
			set this_item to item i of the returned_events
			if the class of this_item is event then
				set the end of these_events to this_item
			else if the class of this_item is list then
				repeat with z from 1 to the count of this_item
					set this_event to item z of this_item
					if the class of this_event is event then
						set the end of these_events to this_event
					end if
				end repeat
			end if
		end repeat
		set the event_count to the count of these_events
		set the event_summary to "J_[" & source_calendar & return & ": " & range_text & return & "Cxg: " & (the event_count as string)
		if the event_count is 0 then
			return the event_summary
		else
			set the event_summary to the event_summary & return
		end if
		repeat with i from 1 to the event_count
			set this_event to item i of these_events
			set the event_properties to the properties of this_event
			--set this_description to description of the event_properties
			set this_summary to the summary of the event_properties
			set this_location to the location of the event_properties
			if this_location is missing value then set this_location to "Ȃ"
			set start_date to short date string of (get start date of the event_properties)
			set start_time to time string of (get start date of the event_properties)
			set end_date to short date string of (get end date of the event_properties)
			set end_time to time string of (get end date of the event_properties)
			set event_description to the description of the event_properties
			set event_URL to the url of the event_properties
			if event_URL is missing value then set event_URL to "Ȃ"
			set the event_status to the status of the event_properties
			if the event_status is none then
				set the event_status to "Ȃ"
			else if the event_status is confirmed then
				set the event_status to "mF܂"
			else if the event_status is tentative then
				set the event_status to ""
			else
				set the event_status to "LZ܂"
			end if
			set the event_recurrence to recurrence of the event_properties
			--return stamp date of the event_properties
			--return sequence of the event_properties
			set the summary_text to "Tv:" & tab & this_summary
			set the location_text to "ꏊ:" & tab & this_location
			set the startdate_text to "Jn t:" & tab & start_date
			set the enddate_text to "I t:" & tab & end_date
			set the starttime_text to "Jn :" & tab & start_time
			set the endtime_text to "I :" & tab & end_time
			set the URL_text to "URL:" & tab & event_URL
			set the status_text to ":" & tab & event_status
			set the date_text to "t:" & tab & start_date & " to " & end_date
			set the time_text to ":" & tab & start_time & " to " & end_time
			set the description_text to ":" & tab & event_description
			--set the recurrence_text to "JԂ:" & tab & event_recurrence
			(* attendee is broken. does not return correct values.
			set the attendee_data to ""
			set the attendee_list to  every attendee of this_event
			set the attendee_count to the count of the attendee_list
			repeat with i from 1 to the attendee_count
				set this_attendee to item i of the attendee_list
				set the attendee_name to the display name of this_attendee
				-- set the attendee_status to the participation status of this_attendee
				set the attendee_email to the email of this_attendee
				if i is 1 then
					set the attendee_data to the attendee_data & the attendee_name & tab & the attendee_email
				else
					set the attendee_data to the attendee_data & return & the attendee_name & tab & the attendee_email
				end if
			end repeat
*)
			set the event_text to the summary_text & return & the status_text & return & the date_text & return & the time_text & return & the location_text & return & the URL_text & return & the description_text
			set the event_summary to event_summary & return & "Cxg " & (event_count as string) & "/ " & (i as string)  & return & event_text & return
		end repeat
		return the event_summary
	end tell
end calendar_events

on week_of(this_date)
	-- get beginning of week
	-- reset to midnight
	set the temp_date to (this_date - (time of this_date))
	repeat 7 times
		if (the weekday of temp_date) is Sunday then
			set the start_day to the temp_date
			exit repeat
		else
			set the temp_date to the temp_date - (1 * days)
		end if
	end repeat
	-- get end of week
	-- reset to midnight
	set the temp_date to (this_date - (time of this_date))
	repeat 7 times
		if (the weekday of temp_date) is Saturday then
			set the end_day to (the temp_date + 43199)
			exit repeat
		else
			set the temp_date to the temp_date + (1 * days)
		end if
	end repeat
	return {start_day, end_day}
end week_of

on month_of(this_date)
	set the target_month to month of this_date
	-- get beginning of month
	-- reset to midnight
	set the temp_date to (this_date - (time of this_date))
	repeat 31 times
		if (the day of temp_date) is 1 then
			set the start_day to the temp_date
			exit repeat
		else
			set the temp_date to the temp_date - (1 * days)
		end if
	end repeat
	-- get end of month
	-- reset to midnight
	set the temp_date to (this_date - (time of this_date))
	repeat 31 times
		if (the month of temp_date) is not the target_month then
			set the end_day to (the temp_date - 1)
			exit repeat
		else
			set the temp_date to the temp_date + (1 * days)
		end if
	end repeat
	return {start_day, end_day}
end month_of
