Set sObjArgs = WScript.Arguments
Set sObjApp = CreateObject("Outlook.Application")
Set sObjNamespace = sObjApp.GetNamespace("MAPI")

If sObjArgs.Count > 0 Then
    strAction = sObjArgs(0)

    Select Case strAction 

        Case "Get Contacts"
            GetContacts sObjArgs(1) 'Puts the list of all contacts into stdout

        Case "New Contacts"
            NewContacts sObjArgs(1) 'Takes the list of new contacts from stdin

        Case "Modified Contacts"
            ModifiedContacts  'Takes the list of modified contacts from stdin

        Case "Get Meetings"
            GetMeetings sObjArgs(1), sObjArgs(2), sObjArgs(3)

        Case "New Meetings"
            NewMeetings sObjArgs(1) 'Takes the list of new meetings from stdin

        Case "Modified Meetings"
            ModifiedMeetings  'Takes the list of modified meetings from stdin

        Case "Get Tasks"
            GetTasks sObjArgs(1), sObjArgs(2), sObjArgs(3)

        Case "New Tasks"
            NewTasks sObjArgs(1) 'Takes the list of new tasks from stdin

        Case "Modified Tasks"
            ModifiedTasks  'Takes the list of modified tasks from stdin

        Case "Get All Items"
            GetAllItems  sObjArgs(1), sObjArgs(2), sObjArgs(3) 'Puts all contacts, meetings and tasks into stdout
    End Select

Else
    MsgBox "Invalid number of arguments!"

End If

Set sObjApp = Nothing
Set sObjArgs = Nothing
Set sObjNamespace = Nothing



Sub GetAllItems(Category, StartDate, EndDate)
   GetContacts Category
   WScript.StdOut.Write vbLF 
   GetMeetings Category, StartDate, EndDate
   WScript.StdOut.Write vbLF 
   GetTasks Category, StartDate, EndDate

End Sub



Sub GetTasks(Category, StartDate, EndDate)
    Dim strOutput
    On Error Resume Next
    strOutput = ""
    strRange = "[Complete] = False OR [DueDate] = NULL OR ([DueDate] >= '" & StartDate & "' AND [DueDate] <= '" & EndDate & "')" 

    If Category <> "InvalidCategoryName" Then
      strRange = strRange & " AND [Categories] = '" & Category & "'"  
    End If

    Set objTasks = sObjNamespace.GetDefaultFolder(13).Items.Restrict(strRange)

    strType = TypeName(objTasks)
    If Err = 0 AND strType <> "Nothing" AND strType <> "Empty" Then
       For Each objTask in objTasks
           With objTask 
                strOutput = strOutput & .EntryID & vbTab & .Subject & vbTab & DateValue(.DueDate) & vbTab & .Complete & vbTab & DateValue(.DateCompleted) & vbTab
                strOutput = strOutput & .Body & vbTab & DateValue(.CreationTime) & vbTab & .Owner & vbCr 
           End With
       Next
    Else
      Err.Clear
    End If

    WScript.StdOut.Write strOutput  'Writes all tasks info back to calling application
    Set objTasks = Nothing

End Sub


Sub ModifiedTasks()
    Dim strInput
    Dim strOutput 
    Dim strFilter 
    Dim objTask 
    On Error Resume Next

    Do While Not WScript.StdIn.AtEndOfStream
         strInput = WScript.StdIn.ReadLine
         Values = Split(strInput, vbTab)
         If UBOUND(Values) > 5 Then

            TheStoreID = sObjNamespace.GetDefaultFolder(13).StoreID

            Set objTask = sObjNamespace.GetItemFromID(values(0), TheStoreID)

            if Err = 0 then
                With objTask 
                    EndChange = Values(3) <> FormatDateTime(.End, 4) 
                    If Values(1) <> .DueDate Or Values(2) <> .DateCompleted Or Values(3) <> .Complete Or Values(4) <> .Subject Or Values(5) <> .Body Then
                       If Len(Values(1)) > 0 Then
                          .DueDate = Values(1)
                       Else
                          .DueDate = #1/1/4501#
                       End If
                       If Len(Values(2)) > 0 Then
                          .DateCompleted = Values(2)
                       Else
                          .DateCompleted = #1/1/4501#
                       End If
                       .Complete = Values(3) 
                       .Subject = Values(4)
                       .Body = Values(5)
                       .Save
                        strOutput = strOutput + Values(0) + vbTab + Values(6) + vbCr 'GUID plus Version
                     End If
                 End With
             Else
                 Err.Clear
                 strOutput = strOutput + Values(0) + vbTab + "-1" + vbCr  'Will use to indicate that it is gone
             End if
         End If
    Loop
    Set objTask = Nothing
    WScript.StdOut.Write strOutput   'Writes the new Entry IDs back to the calling app

End Sub


Sub NewTasks(Category)
    Dim strInput
    Dim strOutput
     
    Do While Not WScript.StdIn.AtEndOfStream
       strInput = WScript.StdIn.ReadLine
       Values = Split(strInput, vbTab)
       If UBound(Values) > 4 Then
            'Set objTask = sObjApp.CreateItem(3)  'Task Item
            Set objTask = sObjNamespace.GetDefaultFolder(13).Items.Add  'Task Item
            With objTask
                If Len(Values(1)) > 0 Then .DueDate = Values(1)
                If Len(Values(2)) > 0 Then .DateCompleted = Values(2)
                .Complete = Values(3)
                .Subject = Values(4)
                .Body = Values(5)
                .Categories = Category
                .ReminderSet = False
                .Save
                strOutput = strOutput + Values(0) + vbTab + .EntryID + vbCr
             End With            
         End If
    Loop
    Set objTask = Nothing    
    WScript.StdOut.Write strOutput  'Writes the new Entry IDs back to the calling app

End Sub


Sub GetMeetings(Category, StartDate, EndDate)
    Dim strOutput
    On Error Resume Next

    strOutput = ""

    strRange = "[Start] >= '" & StartDate & " 00:00' AND [Start] <= '" & EndDate & " 23:59'"

    If Category <> "InvalidCategoryName" Then
       strRange = strRange & " AND [Categories] = '" & Category & "'"  
    End If

    Set objMeetings = sObjNamespace.GetDefaultFolder(9).Items.Restrict(strRange)

    strType = TypeName(objMeetings)

    If Err = 0 AND strType <> "Nothing" AND strType <> "Empty" Then
       For Each objMeeting in objMeetings 
           With objMeeting 
                strOutput = strOutput & .EntryID & vbTab & .Subject + vbTab & .MeetingStatus & vbTab & .AllDayEvent & vbTab
                strOutput = strOutput & .Body & vbTab & DateValue(.CreationTime) & vbTab & FormatDateTime(.CreationTime, 4) & vbTab & DateValue(.LastModificationTime) & vbTab & FormatDateTime(.LastModificationTime, 4)
                strOutput = strOutput & vbTab & .Location & vbTab & .Organizer & vbTab                                                     
                strOutput = strOutput & DateValue(.Start) & vbTab & FormatDateTime(.Start, 4) & vbTab & DateValue(.End) & vbTab & FormatDateTime(.End, 4) & vbCr
           End With
       Next
    Else
       Err.Clear
    End If

    WScript.StdOut.Write strOutput  'Writes all meeting info back to calling application
    Set objMeetings = Nothing

End Sub


Sub ModifiedMeetings()
    Dim strInput
    Dim strOutput 
    Dim strFilter 
    Dim objMeeting 
    On Error Resume Next

    Do While Not WScript.StdIn.AtEndOfStream
         strInput = WScript.StdIn.ReadLine
         Values = Split(strInput, vbTab)
         If UBOUND(Values) > 4 Then

             TheStoreID = sObjNamespace.GetDefaultFolder(9).StoreID

             Set objMeeting = sObjNamespace.GetItemFromID(values(0), TheStoreID)

             if Err = 0 then
                 With objMeeting 

                     AllDayEvent = ((Len(Values(2)) = 0) OR (Len(Values(3)) = 0))
                     If AllDayEvent Then
                        StartChange = Values(1)  <> DateValue(.Start)
                        EndChange = StartChange 

                     Else
                        StartChange = (Values(1) & " " & Values(2)) <> .Start
                        EndChange = Values(3) <> FormatDateTime(.End, 4) 

                     End If

                     If AllDayEvent <> .AllDayEvent Or StartChange Or EndChange Or .Location <> Values(4) Or .Subject <> Values(5) Then
                         If AllDayEvent Then
                            .Start = Values(1) 'No time component on AllDayEvents
                            .End = .Start + 1
                            .AllDayEvent = True
                         Else
                           WasAllDayEvent = .AllDayEvent
                           .AllDayEvent = False
                           .Start = Values(1) & " " & Values(2)

                           If WasAllDayEvent then
                             .End = Values(1) & " " & Values(3)  'Is currently switching from AllDayEvent to timed event
                           Else
                             .End = DateValue(.End) & " " & Values(3)  'We don't want to change the end date because we don't track it in 4D Meetings
                           End If

                         End If

                         .Location = Values(4)
                         .Subject = Values(5)
                         .Save
                         strOutput = strOutput + Values(0) + vbTab + Values(6) + vbCr 'GUID plus Version
                     End If
                 End With
             Else
                 Err.Clear
                 strOutput = strOutput + Values(0) + vbTab + "-1" + vbCr  'Will use to indicate that it is gone
             End if
        End If
    Loop
    Set objMeeting = Nothing
    WScript.StdOut.Write strOutput   'Writes the new Entry IDs back to the calling app

End Sub


Sub NewMeetings(Category)
    Dim strInput
    Dim strOutput
    Do While Not WScript.StdIn.AtEndOfStream
       strInput = WScript.StdIn.ReadLine
       Values = Split(strInput, vbTab)
       If UBound(Values) > 4 Then
           'Set objMeeting = sObjApp.CreateItem(1)  'Appointment Item
           Set objMeeting = sObjNamespace.GetDefaultFolder(9).Items.Add  'Appointment Item
           With objMeeting 
               .AllDayEvent = ((Len(Values(2)) = 0) OR (Len(Values(3)) = 0))
               If .AllDayEvent Then
                  .Start = Values(1) 'No time component on AllDayEvents
                  .End = .Start + 1
               Else
                  .Start = Values(1) & " " & Values(2)
                  .End = DateValue(.End) & " " & Values(3) 'We don't want to change the end date because we don't track it in 4D Meetings
               End If
               .Location = Values(4)
               .Subject = Values(5)
               .Categories = Category
               .ReminderSet = False
               .Save
               strOutput = strOutput + Values(0) + vbTab + .EntryID + vbCr
            End With
       End If
    Loop

    Set objMeeting = Nothing    
    WScript.StdOut.Write strOutput  'Writes the new Entry IDs back to the calling app

End Sub


Sub GetContacts(Category)
    Dim strOutput
    Set objContacts = sObjNamespace.GetDefaultFolder(10).Items

    If Category <> "InvalidCategoryName" Then
        strFilter = "[Categories] = '" & Category & "'"  
        Set objContacts = sObjNamespace.GetDefaultFolder(10).Items.Restrict(strFilter)
    End If

    strType = TypeName(objContacts)

    If Err = 0 AND strType <> "Nothing" Then
       For Each objContact in objContacts
           With objContact
               strOutput = strOutput + .EntryID + vbTab + .FirstName + vbTab + .LastName + vbTab + .businessAddressStreet + vbTab _
               + .businessAddressCity + vbTab + .businessAddressState + vbTab + .businessAddressPostalCode + vbTab + .businessAddressCountry + vbTab + .Email1Address + vbTab _
               + .CompanyName + vbTab + .BusinessTelephoneNumber + vbTab + .BusinessFaxNumber + vbTab + .WebPage + vbTab + .Body + vbCr
           End With
       Next
     Else
        Err.Clear
     End If

    WScript.StdOut.Write strOutput  'Writes all contact info back to calling application
    Set objContacts = Nothing
End Sub


Sub ModifiedContacts()
    Dim strInput
    Dim strOutput 
    Dim strFilter 
    Dim objContact
    On Error Resume Next

    Do While Not WScript.StdIn.AtEndOfStream
         strInput = WScript.StdIn.ReadLine
         Values = Split(strInput, vbTab)
         If UBOUND(Values) > 4 Then

             TheStoreID = sObjNamespace.GetDefaultFolder(10).StoreID

             Set objContact = sObjNamespace.GetItemFromID(values(0), TheStoreID)

             If Err = 0 then
                 With objContact
                     If .FirstName <> Values(1) Or .LastName <> Values(2) Or .businessAddressStreet <> Values(3) Or .businessAddressCity <> Values(4) Or .businessAddressState <> Values(5) Or .businessAddressPostalCode <> Values(6) Or .businessAddressCountry <> Values(7) Or .Email1Address <> Values(8) Or .CompanyName <> Values(9) Or .BusinessTelephoneNumber <> Values(10) Or .BusinessFaxNumber <> Values(11) Or .WebPage <> Values(12) Or .Body <> Values(13) Then
                         .FirstName = Values(1)
                         .LastName = Values(2)
                         .businessAddressStreet = Values(3)
                         .businessAddressCity = Values(4)
                         .businessAddressState = Values(5)
                         .businessAddressPostalCode = Values(6)
                         .businessAddressCountry = Values(7)
                         .Email1Address = Values(8)
                         .CompanyName = Values(9)
                         .BusinessTelephoneNumber = Values(10)
                         .BusinessFaxNumber = Values(11)
                         .WebPage = Values(12)
                         .Body = Values(13)
                         .Save
                        strOutput = strOutput + Values(0) + vbTab + Values(6) + vbCr
                     End If
                 End With
              Else
                  Err.Clear
                  strOutput = strOutput + Values(0) + vbTab + "-1" + vbCr  'Will use to indicate that it is gone
              End if
         End If
    Loop
    Set objContact = Nothing
    WScript.StdOut.Write strOutput   'Writes the new Entry IDs back to the calling app
 
End Sub


Sub NewContacts(Category)

    Dim strInput
    Dim strOutput

    Do While Not WScript.StdIn.AtEndOfStream
       strInput = WScript.StdIn.ReadLine
       Values = Split(strInput, vbTab)
       If UBound(Values) > 4 Then
            Set objContact = sObjNamespace.GetDefaultFolder(10).Items.Add
            With objContact
               .FirstName = Values(1)
               .LastName = Values(2)
               .businessAddressStreet = Values(3)
               .businessAddressCity = Values(4)
               .businessAddressState = Values(5)
               .businessAddressPostalCode = Values(6)
               .businessAddressCountry = Values(7)
               .Email1Address = Values(8)
               .CompanyName = Values(9)
               .BusinessTelephoneNumber = Values(10)
               .BusinessFaxNumber = Values(11)
               .WebPage = Values(12)
               .Body = Values(13)
               .Categories = Category
               .Save

               strOutput = strOutput + Values(0) + vbTab + .EntryID + vbCr
            End With            
        End If
    Loop

    Set objContact = Nothing    
    WScript.StdOut.Write strOutput  'Writes the new Entry IDs back to the calling app
    
End Sub

