Set sObjArgs = WScript.Arguments
Set sObjApp = CreateObject("Outlook.Application")
Set sObjNamespace = sObjApp.GetNamespace("MAPI")

If sObjArgs.Count > 0 Then
    strAction = sObjArgs(0)

    GetMeetings sObjArgs(0), sObjArgs(1), sObjArgs(2)
    WScript.StdOut.Write vbLF 

Else
    MsgBox "Invalid number of arguments!"

End If

Set sObjApp = Nothing
Set sObjArgs = Nothing
Set sObjNamespace = Nothing

Sub GetMeetings(Category, StartDate, EndDate)
    Dim strOutput
    On Error Resume Next

    strOutput = ""

    strRange = "[Start] >= '" & StartDate & " 00:00' AND [Start] <= '" & EndDate & " 23:59'"

    Set objMeetings = sObjNamespace.GetDefaultFolder(9).Items.Restrict(strRange)

    strType = TypeName(objMeetings)

    If Err = 0 AND strType <> "Nothing" AND strType <> "Empty" Then
       For Each objMeeting in objMeetings 
         If Category = "InvalidCategoryName" Then 
             With objMeeting 
                  strOutput = strOutput & .Subject + Chr(1) & .Body & Chr(1) & .Location & Chr(1)
                  strOutput = strOutput & FormatDateTime(.Start, 4) & Chr(1) & FormatDateTime(.End, 4) & Chr(1)
                  strOutput = strOutput & DateValue(.End) & vbCr
             End With
           Else
            If InStr(1, objMeeting.Categories, Category) Then 
               With objMeeting 
                  strOutput = strOutput & .EntryID & vbTab & .Subject + vbTab & .MeetingStatus & vbTab & .AllDayEvent & vbTab
                  strOutput = strOutput  & DateValue(.CreationTime) & vbTab & FormatDateTime(.CreationTime, 4) & vbTab & DateValue(.LastModificationTime) & vbTab & FormatDateTime(.LastModificationTime, 4)
                  strOutput = strOutput & vbTab & .Location & vbTab & .Organizer & vbTab 
                  strOutput = strOutput & DateValue(.Start) & vbTab & FormatDateTime(.Start, 4) & vbTab & DateValue(.End) & vbTab & FormatDateTime(.End, 4) & vbCr
               End With
             End If
           End If
       Next
    Else
       Err.Clear
    End If

    WScript.StdOut.Write strOutput  'Writes all meeting info back to calling application
    Set objMeetings = Nothing

End Sub


Sub ModifiedMeetings()
    Dim strInput
    Dim strOutput 
    Dim strFilter 
    Dim objMeeting 
    On Error Resume Next

    Do While Not WScript.StdIn.AtEndOfStream
         strInput = WScript.StdIn.ReadLine
         Values = Split(strInput, vbTab)
         If UBOUND(Values) > 4 Then

             TheStoreID = sObjNamespace.GetDefaultFolder(9).StoreID

             Set objMeeting = sObjNamespace.GetItemFromID(values(0), TheStoreID)

             if Err = 0 then
                 With objMeeting 

                     AllDayEvent = ((Len(Values(2)) = 0) OR (Len(Values(3)) = 0))
                     If AllDayEvent Then
                        StartChange = Values(1)  <> DateValue(.Start)
                        EndChange = StartChange 

                     Else
                        StartChange = (Values(1) & " " & Values(2)) <> .Start
                        EndChange = Values(3) <> FormatDateTime(.End, 4) 

                     End If

                     If AllDayEvent <> .AllDayEvent Or StartChange Or EndChange Or .Location <> Values(4) Or .Subject <> Values(5) Then
                         If AllDayEvent Then
                            .Start = Values(1) 'No time component on AllDayEvents
                            .End = .Start + 1
                            .AllDayEvent = True
                         Else
                           WasAllDayEvent = .AllDayEvent
                           .AllDayEvent = False
                           .Start = Values(1) & " " & Values(2)

                           If WasAllDayEvent then
                             .End = Values(1) & " " & Values(3)  'Is currently switching from AllDayEvent to timed event
                           Else
                             .End = DateValue(.End) & " " & Values(3)  'We don't want to change the end date because we don't track it in 4D Meetings
                           End If

                         End If

                         .Location = Values(4)
                         .Subject = Values(5)
                         .Save
                         strOutput = strOutput + Values(0) + vbTab + Values(6) + vbCr 'GUID plus Version
                     End If
                 End With
             Else
                 Err.Clear
                 strOutput = strOutput + Values(0) + vbTab + "-1" + vbCr  'Will use to indicate that it is gone
             End if
        End If
    Loop
    Set objMeeting = Nothing
    WScript.StdOut.Write strOutput   'Writes the new Entry IDs back to the calling app

End Sub


Sub NewMeetings(Category)
    Dim strInput
    Dim strOutput
    Do While Not WScript.StdIn.AtEndOfStream
       strInput = WScript.StdIn.ReadLine
       Values = Split(strInput, vbTab)
       If UBound(Values) > 4 Then
           'Set objMeeting = sObjApp.CreateItem(1)  'Appointment Item
           Set objMeeting = sObjNamespace.GetDefaultFolder(9).Items.Add  'Appointment Item
           With objMeeting 
               .AllDayEvent = ((Len(Values(2)) = 0) OR (Len(Values(3)) = 0))
               If .AllDayEvent Then
                  .Start = Values(1) 'No time component on AllDayEvents
                  .End = .Start + 1
               Else
                  .Start = Values(1) & " " & Values(2)
                  .End = DateValue(.End) & " " & Values(3) 'We don't want to change the end date because we don't track it in 4D Meetings
               End If
               .Location = Values(4)
               .Subject = Values(5)
               .Categories = Category
               .ReminderSet = False
               .Save
               strOutput = strOutput + Values(0) + vbTab + .EntryID + vbCr
            End With
       End If
    Loop

    Set objMeeting = Nothing    
    WScript.StdOut.Write strOutput  'Writes the new Entry IDs back to the calling app

End Sub

